"""
# To generate station_tag_signing_key.pem:
$ openssl ecparam -genkey -name prime256v1 -out station_tag_signing_key.pem

# Then extract the verification key from it:
$ openssl ec -in station_tag_signing_key.pem -pubout -out station_tag_verification_key.pem
"""

SIGNATURE_ENABLED = False
from nfc.ndef.signature import SignatureType, CertificateFormat
if SIGNATURE_ENABLED:
    import m2m_certificates as m2m

import os

configuration_path = os.path.join("/media/",os.getenv("USER"), "nfc_config/")  # os.path.abspath(os.path.dirname(__file__))

class SignatureConfiguration(object):
    signature_enabled = SIGNATURE_ENABLED

    # Use the generate_tag_signing_key script to generate these
    station_signing_key_path = os.path.join(configuration_path, "station_tag_signing_key.pem")
    station_verification_key_path = os.path.join(configuration_path, "station_tag_verification_key.pem")
    station_certificate_path = os.path.join(configuration_path, "station_certificate.pem")

    ultimaker_verification_key_path = os.path.join(configuration_path, "ultimaker_certificate_verification_key.pem")

    signature_type = SignatureType.ECDSA_DSS_P256
    signature_uri = None

    # The first element of the certificate chain must be the bytes of the DER encoded M2M certificate, such as
    # generated by $ python3 -m taranis.scripts.generate_station_certificate
    @staticmethod
    def getCertificateChain():
        certificate_chain = [m2m.contentbytes_from_pem_file(SignatureConfiguration.station_certificate_path)]
        return certificate_chain

    # TODO: define the Ultimaker certificate URI and actually put the certificate there
    # The tags are too small to contain the whole certificate. Therefore, we only put the first certificate on the tag and then point to the Ultimaker certificate with an URI
    next_certificate_uri = "https://www.ultimaker.com/rfid/tag_certificate.crt"
    certificate_format = CertificateFormat.M2M